'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getStyle = function getStyle(el, str) {
  return parseInt(getComputedStyle(el).getPropertyValue(str), 10);
};

var getWidth = function getWidth(el) {
  var width = 0;
  var pLeft = getStyle(el, 'padding-left');
  var pRight = getStyle(el, 'padding-right');
  if (el.childElementCount) {

    var child = el.childNodes[0];
    var mLeft = getStyle(child, 'margin-left');
    var mRight = getStyle(child, 'margin-right');
    var cWidth = child.scrollWidth;

    return cWidth + mLeft + mRight + pLeft + pRight;
  }
  return el.offsetWidth;
};

var getHeight = function getHeight(el) {
  var height = 0;
  var pTop = getStyle(el, 'padding-top');
  var pBottom = getStyle(el, 'padding-top');
  var elHeight = 0;
  if (el.childElementCount) {

    var child = el.childNodes[0];
    var mTop = getStyle(child, 'margin-top');
    var mBottom = getStyle(child, 'margin-bottom');
    var cHeight = child.offsetHeight;
    return cHeight + mBottom + mTop + pTop + pBottom;
  }
  return el.offsetHeight;
};

var ReactBootstrapSwitcher = function (_React$Component) {
  _inherits(ReactBootstrapSwitcher, _React$Component);

  function ReactBootstrapSwitcher(props) {
    _classCallCheck(this, ReactBootstrapSwitcher);

    //set the state to either the prop.active value or default it to true

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReactBootstrapSwitcher).call(this, props));

    _this.state = { active: typeof props.active !== 'undefined' ? props.active : true };
    return _this;
  }

  _createClass(ReactBootstrapSwitcher, [{
    key: 'onClick',
    value: function onClick() {
      if (this.props.disabled) return;
      this.props.onChange && this.props.onChange(!this.state.active);
      this.setState({ active: !this.state.active });
    }
  }, {
    key: 'setDimensions',
    value: function setDimensions() {
      var on = this.refs.on;
      var off = this.refs.off;
      var toggle = this.refs.toggle;
      var width = Math.max(getWidth(on), getWidth(off));
      console.log(width);
      var height = Math.max(getHeight(on), getHeight(off));
      console.log(this.refs.switcher.offsetHeight);
      this.setState({ width: this.props.width || width, height: this.props.height || height });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setDimensions();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(p) {
      this.setDimensions();
    }
  }, {
    key: 'getSizeClass',
    value: function getSizeClass() {
      switch (this.props.size) {
        case 'large':
          return 'btn-lg';
          break;
        case 'small':
          return 'btn-sm';
          break;
        case 'mini':
          return 'btn-xs';
          break;
        default:
          return '';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var onstyle = 'btn-' + this.props.onstyle;
      var offstyle = 'btn-' + this.props.offstyle;
      var btn = 'btn';
      var toggleOn = 'toggle-on';
      var toggleOff = 'toggle-off';
      var sizeClass = this.getSizeClass();
      var activeClass = btn + ' toggle ' + sizeClass + ' ' + onstyle;
      var inactiveClass = btn + ' toggle ' + sizeClass + ' ' + offstyle + ' off';

      var onStyleClass = btn + ' ' + toggleOn + ' ' + sizeClass + ' ' + onstyle;
      var offStyleClass = btn + ' ' + toggleOff + ' ' + sizeClass + ' ' + offstyle;

      var style = {
        width: this.state.width,
        height: this.state.height
      };

      return _react2.default.createElement(
        'div',
        { ref: 'switcher', disabled: this.props.disabled, className: this.state.active ? activeClass : inactiveClass,
          onClick: this.onClick.bind(this), style: style },
        _react2.default.createElement(
          'div',
          { className: 'toggle-group' },
          _react2.default.createElement(
            'label',
            { ref: 'on', className: onStyleClass },
            this.props.on
          ),
          _react2.default.createElement(
            'label',
            { ref: 'off', className: offStyleClass },
            this.props.off
          ),
          _react2.default.createElement('span', { ref: 'toggle', className: 'toggle-handle btn btn-default' })
        )
      );
    }
  }]);

  return ReactBootstrapSwitcher;
}(_react2.default.Component);

exports.default = ReactBootstrapSwitcher;

ReactBootstrapSwitcher.propTypes = {
  // Holds the className for label one
  onstyle: _react2.default.PropTypes.string,
  // Holds the className for label two
  offstyle: _react2.default.PropTypes.string,
  // Height prop
  height: _react2.default.PropTypes.string,
  // Width prop
  width: _react2.default.PropTypes.string,
  // The on and off elements defaults to 'On' and 'Off'
  on: _react2.default.PropTypes.node,
  off: _react2.default.PropTypes.node,
  // The initial state of the component
  active: _react2.default.PropTypes.bool,
  // Sets the button to disabled
  disabled: _react2.default.PropTypes.bool,
  // Set the size of the button defaults to normal
  size: _react2.default.PropTypes.string,
  // The onChange event, returns the state as the argument
  onChange: _react2.default.PropTypes.func
};

ReactBootstrapSwitcher.defaultProps = {
  onstyle: 'primary',
  offstyle: 'default',
  width: '',
  height: '',
  on: 'On',
  off: 'Off',
  disabled: false,
  size: 'normal',
  active: true
};